@echo off
rem		/*****************************************
rem		file	: UP898SRREG.bat
rem		note	: A batch file to set registories for printer driver
rem		target	: Printer Driver for Sony UP-898 Series
rem		version : 1.00 T1
rem		Copyright 2017 Sony Corporation
rem		*****************************************/

rem	//////////////////////////////////////////////
rem	// Check Architecture
rem	//////////////////////////////////////////////
if "%PROCESSOR_ARCHITECTURE%" EQU "x86" (
  set DRVSTORED_PATH=%SYSTEMROOT%\System32\spool\drivers\w32x86\3
)
if "%PROCESSOR_ARCHITECTURE%" NEQ "x86" (
  set DRVSTORED_PATH=%SYSTEMROOT%\System32\spool\drivers\x64\3
)

rem	//////////////////////////////////////////////
rem	// Definition
rem	//////////////////////////////////////////////
set REG_KEY=HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Print\Monitors
set REG_SUBKEY=Sony UP-898 Series Language Monitor
set REG_FULLKEY="%REG_KEY%\%REG_SUBKEY%"

set REG_EVENTLOG_KEY=HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Eventlog
set REG_EVENTLOG_KEY_ONLINE=UP-898Series_ONLINE
set REG_EVENTLOG_KEY_OFFLINE=UP-898Series_OFFLINE

set REG_CANCEL_VALUE=StatusMonittor_Cancel
set REG_CANCELNOTIFY_VALUE=StatusMonittor_CancelNotify
set REG_EVENT_VALUE=StatusMonittor_Event
set REG_EVENT_ACCESS_VALUE=CustomSD
set REG_EVENTLOG_CUSTOMSD_VALUE="O:BAG:SYD:(A;;0x02;;;WD)(A;;0x01;;;WD)(A;;0x04;;;WD)"
set REG_EVENTLOG_MSGFILE_LGFILE=UP898SRLOG.dll
set REG_EVENTLOG_MSGFILE_VALUE="%DRVSTORED_PATH%\%REG_EVENTLOG_MSGFILE_LGFILE%"
set REG_EVENTLOG_TYPESUP_VALUE=7

set param1=0
set param2=0
set param3=0
set param4=0



rem	//////////////////////////////////////////////
rem	// Check parameter
rem	//////////////////////////////////////////////
if "%1"=="" goto usage
if "%2"=="" goto usage
if "%3"=="" goto usage
if "%4"=="" goto usage



rem	//////////////////////////////////////////////
rem	// StatusMonittor_Cancel_Button
rem	//////////////////////////////////////////////
if "%1"=="0" goto delete_StatusMonittor_Cancel
if "%1"=="1" goto add_StatusMonittor_Cancel
if "%1"=="2" goto add_StatusMonittor_Cancel
goto keep_StatusMonittor_Cancel

rem	----- delete Registory value for showing Cancel Button -----
:delete_StatusMonittor_Cancel
echo --^> 1st param (%1) : Delete Registory value for showing Cancel Button!
reg query %REG_FULLKEY% /v %REG_CANCEL_VALUE% 1>nul 2>&1
if not ErrorLevel 1 goto delete_StatusMonittor_Cancel_done
echo ^>reg delete %REG_CANCEL_VALUE%
echo The operation completed successfully. (already none)
goto set_StatusMonittor_CancelNotify

:delete_StatusMonittor_Cancel_done
echo ^>reg delete %REG_CANCEL_VALUE%
reg delete %REG_FULLKEY% /v %REG_CANCEL_VALUE% /f
goto set_StatusMonittor_CancelNotify

rem	----- add Registory value for showing Cancel Button -----
:add_StatusMonittor_Cancel
echo --^> 1st param (%1) : Add Registory value for showing Cancel Button!
reg add %REG_FULLKEY% /v %REG_CANCEL_VALUE% /t REG_DWORD /d %1 /f
goto set_StatusMonittor_CancelNotify

rem	----- keep Registory value for showing Cancel Button : "%1"==other than "0~2" -----
:keep_StatusMonittor_Cancel
echo --^> 1st param (%1) : Keep current settings for showing Cancel Button!
goto set_StatusMonittor_CancelNotify



rem	//////////////////////////////////////////////
rem	// StatusMonittor_CancelNotify
rem	//////////////////////////////////////////////
:set_StatusMonittor_CancelNotify
echo.
if "%2"=="0" goto delete_StatusMonittor_CancelNotify
if "%2"=="1" goto add_StatusMonittor_CancelNotify
if "%2"=="2" goto add_StatusMonittor_CancelNotify
goto keep_StatusMonittor_CancelNotify

rem	----- delete Registory value for Cancel-Notify -----
:delete_StatusMonittor_CancelNotify
echo --^> 2nd param (%2) : Delete Registory value for Cancel-Notify!
reg query %REG_FULLKEY% /v %REG_CANCELNOTIFY_VALUE% 1>nul 2>&1
if not ErrorLevel 1 goto delete_StatusMonittor_CancelNotify_done
echo ^>reg delete %REG_CANCELNOTIFY_VALUE%
echo The operation completed successfully. (already none)
goto set_StatusMonittor_Event_onoff

:delete_StatusMonittor_CancelNotify_done
echo ^>reg delete %REG_CANCELNOTIFY_VALUE%
reg delete %REG_FULLKEY% /v %REG_CANCELNOTIFY_VALUE% /f
goto set_StatusMonittor_Event_onoff

rem	----- add Registory value for Cancel-Notify -----
:add_StatusMonittor_CancelNotify
echo --^> 2nd param (%2) : Add Registory value for Cancel-Notify!
reg add %REG_FULLKEY% /v %REG_CANCELNOTIFY_VALUE% /t REG_DWORD /d %2 /f
goto set_StatusMonittor_Event_onoff

rem	----- keep Registory value for Cancel-Notify : "%2"==other than "0","1","2" -----
:keep_StatusMonittor_CancelNotify
echo --^> 2nd param (%2) : Keep current settings for Cancel-Notify!
goto set_StatusMonittor_Event_onoff



rem	//////////////////////////////////////////////
rem	// StatusMonittor_Event (on/off)
rem	//////////////////////////////////////////////
:set_StatusMonittor_Event_onoff
echo.
if "%3"=="0" goto delete_StatusMonittor_Event_onoff
if "%3"=="1" goto add_StatusMonittor_Event_onoff
if "%3"=="2" goto add_StatusMonittor_Event_onoff
goto keep_StatusMonittor_Event_onoff

rem	----- delete key for Event log : "%3"=="0" -----
:delete_StatusMonittor_Event_onoff
echo --^> 3rd param (%3) : Delete Registory value for Event log! (on/off)
reg query %REG_FULLKEY% /v %REG_EVENT_VALUE% 1>nul 2>&1
if not ErrorLevel 1 goto delete_StatusMonittor_Event_onoff_done
echo ^>reg delete %REG_EVENT_VALUE%
echo The operation completed successfully. (already none)
goto set_StatusMonitor_Event_select

:delete_StatusMonittor_Event_onoff_done
echo ^>reg delete %REG_EVENT_VALUE%
reg delete %REG_FULLKEY% /v %REG_EVENT_VALUE% /f
goto set_StatusMonitor_Event_select

rem	----- add key for Event log : "%3"=="1" or "2" -----
:add_StatusMonittor_Event_onoff
echo --^> 3rd param (%3) : Add Registory value for Event log! (on/off)
reg add %REG_FULLKEY% /v %REG_EVENT_VALUE% /t REG_DWORD /d %3 /f
goto set_StatusMonitor_Event_select

rem	----- keep key for Event log : "%3"==other than "0","1","2" -----
:keep_StatusMonittor_Event_onoff
echo --^> 3rd param (%3) : Keep current settings for Event log! (on/off)
goto set_StatusMonitor_Event_select



rem	//////////////////////////////////////////////
rem	// StatusMonittor_Event (system/application)
rem	//////////////////////////////////////////////
:set_StatusMonitor_Event_select
echo.
if "%4"=="0" goto delete_StatusMonitor_Event_sys_online
if "%4"=="1" goto add_StatusMonitor_Event_sys_online
if "%4"=="2" goto add_StatusMonitor_Event_apl_online
goto keep_StatusMonitor_Event_select

rem	----- delete key for Event log : "%4"=="0" -----
:delete_StatusMonitor_Event_sys_online
echo --^> 4th param (%4) : Delete Registory key for Event log!
reg query %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_ONLINE% 1>nul 2>&1
if not ErrorLevel 1 goto delete_StatusMonitor_Event_sys_online_done
echo ^>reg delete ...\System\%REG_EVENTLOG_KEY_ONLINE%
echo The operation completed successfully. (already none)
goto delete_StatusMonitor_Event_sys_offline

:delete_StatusMonitor_Event_sys_online_done
echo ^>reg delete ...\System\%REG_EVENTLOG_KEY_ONLINE%
reg delete %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_ONLINE% /f

:delete_StatusMonitor_Event_sys_offline
echo --^> 4th param (%4) : Delete Registory key for Event log!
reg query %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_OFFLINE% 1>nul 2>&1
if not ErrorLevel 1 goto delete_StatusMonitor_Event_sys_offline_done
echo ^>reg delete ...\System\%REG_EVENTLOG_KEY_OFFLINE%
echo The operation completed successfully. (already none)
goto delete_StatusMonitor_Event_sys_CustomSD

:delete_StatusMonitor_Event_sys_offline_done
echo ^>reg delete ...\System\%REG_EVENTLOG_KEY_OFFLINE%
reg delete %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_OFFLINE% /f

:delete_StatusMonitor_Event_sys_CustomSD
reg query %REG_EVENTLOG_KEY%\System /v %REG_EVENT_ACCESS_VALUE% 1>nul 2>&1
if not ErrorLevel 1 goto delete_StatusMonitor_Event_sys_CustomSD_done
echo ^>reg delete ...\System\%REG_EVENT_ACCESS_VALUE%
echo The operation completed successfully. (already none)
goto delete_StatusMonitor_Event_apl_online

:delete_StatusMonitor_Event_sys_CustomSD_done
echo ^>reg delete ...\System\%REG_EVENT_ACCESS_VALUE%
reg delete %REG_EVENTLOG_KEY%\System /v %REG_EVENT_ACCESS_VALUE% /f

:delete_StatusMonitor_Event_apl_online
reg query %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_ONLINE% 1>nul 2>&1
if not ErrorLevel 1 goto delete_StatusMonitor_Event_apl_online_done
echo ^>reg delete ...\Application\%REG_EVENTLOG_KEY_ONLINE%
echo The operation completed successfully. (already none)
goto delete_StatusMonitor_Event_apl_offline

:delete_StatusMonitor_Event_apl_online_done
echo ^>reg delete ...\Application\%REG_EVENTLOG_KEY_ONLINE%
reg delete %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_ONLINE% /f

:delete_StatusMonitor_Event_apl_offline
reg query %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_OFFLINE% 1>nul 2>&1
if not ErrorLevel 1 goto delete_StatusMonitor_Event_apl_onffline_done
echo ^>reg delete ...\Application\%REG_EVENTLOG_KEY_OFFLINE%
echo The operation completed successfully. (already none)
goto end

:delete_StatusMonitor_Event_apl_onffline_done
echo ^>reg delete ...\Application\%REG_EVENTLOG_KEY_OFFLINE%
reg delete %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_OFFLINE% /f
goto end

rem	----- add key for Event log [System] : "%4"=="1" -----
:add_StatusMonitor_Event_sys_online
echo --^> 4th param (%4) : Add Registory key for Event log! [System]

:delete_StatusMonitor_Event_apl_online2
reg query %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_ONLINE% 1>nul 2>&1
if not ErrorLevel 1 goto delete_StatusMonitor_Event_apl_online2_done
echo ^>reg delete ...\Application\%REG_EVENTLOG_KEY_ONLINE%
echo The operation completed successfully. (already none)
goto delete_StatusMonitor_Event_apl_offline2

:delete_StatusMonitor_Event_apl_online2_done
echo ^>reg delete ...\Application\%REG_EVENTLOG_KEY_ONLINE%
reg delete %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_ONLINE% /f

:delete_StatusMonitor_Event_apl_offline2
reg query %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_OFFLINE% 1>nul 2>&1
if not ErrorLevel 1 goto delete_StatusMonitor_Event_apl_offline2_done
echo ^>reg delete ...\Application\%REG_EVENTLOG_KEY_OFFLINE%
echo The operation completed successfully. (already none)
goto add_StatusMonitor_Event_sys_CustomSD

:delete_StatusMonitor_Event_apl_offline2_done
echo ^>reg delete ...\Application\%REG_EVENTLOG_KEY_OFFLINE%
reg delete %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_OFFLINE% /f

:add_StatusMonitor_Event_sys_CustomSD
rem reg query %REG_EVENTLOG_KEY%\System /v %REG_EVENT_ACCESS_VALUE% 1>nul 2>&1
rem if not ErrorLevel 1 goto add_StatusMonitor_Event_sys_CustomSD_done
rem echo ^>reg add ...\System /v %REG_EVENT_ACCESS_VALUE%
rem echo The operation completed successfully. (already none)
rem goto add_StatusMonitor_Event_sys_done

:add_StatusMonitor_Event_sys_CustomSD_done
echo ^>reg add ...\System /v %REG_EVENT_ACCESS_VALUE%
reg add %REG_EVENTLOG_KEY%\System /v %REG_EVENT_ACCESS_VALUE% /t REG_SZ /d %REG_EVENTLOG_CUSTOMSD_VALUE% /f

:add_StatusMonitor_Event_sys_done
echo ^>reg add ...\System\%REG_EVENTLOG_KEY_ONLINE%
reg add %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_ONLINE% /f
echo ^>reg add ...\System\%REG_EVENTLOG_KEY_ONLINE% /v EventMessageFile ...
reg add %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_ONLINE% /v EventMessageFile /t REG_EXPAND_SZ /d %REG_EVENTLOG_MSGFILE_VALUE% /f
echo ^>reg add ...\System\%REG_EVENTLOG_KEY_ONLINE% /v TypesSupported ...
reg add %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_ONLINE% /v TypesSupported /t REG_DWORD /d 7 /f

echo ^>reg add ...\System\%REG_EVENTLOG_KEY_OFFLINE%
reg add %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_OFFLINE% /f
echo ^>reg add ...\System\%REG_EVENTLOG_KEY_OFFLINE% /v EventMessageFile ...
reg add %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_OFFLINE% /v EventMessageFile /t REG_EXPAND_SZ /d %REG_EVENTLOG_MSGFILE_VALUE% /f
echo ^>reg add ...\System\%REG_EVENTLOG_KEY_OFFLINE% /v TypesSupported ...
reg add %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_OFFLINE% /v TypesSupported /t REG_DWORD /d 7 /f
goto end

rem	----- add key for Event log [Application] : "%4"=="2" -----
:add_StatusMonitor_Event_apl_online
echo --^> 4th param (%4) : Add Registory key for Event log! [Application]

:delete_StatusMonitor_Event_sys_online2
reg query %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_ONLINE% 1>nul 2>&1
if not ErrorLevel 1 goto delete_StatusMonitor_Event_sys_online2_done
echo ^>reg delete ...\System\%REG_EVENTLOG_KEY_ONLINE%
echo The operation completed successfully. (already none)
goto delete_StatusMonitor_Event_sys_offline2

:delete_StatusMonitor_Event_sys_online2_done
echo ^>reg delete ...\System\%REG_EVENTLOG_KEY_ONLINE%
reg delete %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_ONLINE% /f

:delete_StatusMonitor_Event_sys_offline2
reg query %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_OFFLINE% 1>nul 2>&1
if not ErrorLevel 1 goto delete_StatusMonitor_Event_sys_offline2_done
echo ^>reg delete ...\System\%REG_EVENTLOG_KEY_OFFLINE%
echo The operation completed successfully. (already none)
goto delete_StatusMonitor_Event_sys_CustomSD2

:delete_StatusMonitor_Event_sys_offline2_done
echo ^>reg delete ...\System\%REG_EVENTLOG_KEY_OFFLINE%
reg delete %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_OFFLINE% /f

:delete_StatusMonitor_Event_sys_CustomSD2
reg query %REG_EVENTLOG_KEY%\System /v %REG_EVENT_ACCESS_VALUE% 1>nul 2>&1
if not ErrorLevel 1 goto delete_StatusMonitor_Event_sys_CustomSD2_done
echo ^>reg delete ...\System\%REG_EVENT_ACCESS_VALUE%
echo The operation completed successfully. (already none)
goto add_StatusMonitor_Event_apl_done

:delete_StatusMonitor_Event_sys_CustomSD2_done
echo ^>reg delete ...\System\%REG_EVENT_ACCESS_VALUE%
reg delete %REG_EVENTLOG_KEY%\System /v %REG_EVENT_ACCESS_VALUE% /f

:add_StatusMonitor_Event_apl_done
echo ^>reg add ...\Application\%REG_EVENTLOG_KEY_ONLINE%
reg add %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_ONLINE% /f
echo ^>reg add ...\Application\%REG_EVENTLOG_KEY_ONLINE% /v EventMessageFile ...
reg add %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_ONLINE% /v EventMessageFile /t REG_EXPAND_SZ /d %REG_EVENTLOG_MSGFILE_VALUE% /f
echo ^>reg add ...\Application\%REG_EVENTLOG_KEY_ONLINE% /v TypesSupported ...
reg add %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_ONLINE% /v TypesSupported /t REG_DWORD /d 7 /f

echo ^>reg add ...\Application\%REG_EVENTLOG_KEY_OFFLINE%
reg add %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_OFFLINE% /f
echo ^>reg add ...\Application\%REG_EVENTLOG_KEY_OFFLINE% /v EventMessageFile ...
reg add %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_OFFLINE% /v EventMessageFile /t REG_EXPAND_SZ /d %REG_EVENTLOG_MSGFILE_VALUE% /f
echo ^>reg add ...\Application\%REG_EVENTLOG_KEY_OFFLINE% /v TypesSupported ...
reg add %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_OFFLINE% /v TypesSupported /t REG_DWORD /d 7 /f
goto end

rem	----- keep key for Event log : "%4"==other than "0","1","2" -----
:keep_StatusMonitor_Event_select
echo --^> 4th param (%4) : Keep current settings for Event log! (system/application)
goto end



rem		//////////////////////////////////////////////
rem		// Usage
rem		//////////////////////////////////////////////
:usage
echo;
echo Please input parameter.
echo ex...
echo UP898SRREG.bat a b c d
echo "a"       : Parameter for StatusMonitor Cancel Button
echo              (0):Delete Registry, (1):Hide, (2):View
echo              (other):Keep current settings
echo.
echo "b"       : Parameter for StatusMonitor Cancel Notify
echo              (0):Delete Registry, (1):Disable, (2):Enable
echo              (other):Keep current settings
echo.
echo "c"       : Parameter for StatusMonitor EventLog (on / off)
echo              (0):Delete Registry, (1):On, (2):Off
echo              (other):Keep current settings
echo.
echo "d"       : Parameter for StatusMonitor EventLog (system / application)
echo              (0):Delete Registry, (1):System, (2):Application
echo              (other):Keep current settings



rem		//////////////////////////////////////////////
rem		// Check
rem		//////////////////////////////////////////////
:check
echo;
rem	----- check 1st parameter -----
:check_parameter_1st
reg query %REG_FULLKEY% /v %REG_CANCEL_VALUE% 1>nul 2>&1
if not ErrorLevel 1 goto check_parameter_1st_done
set /a param1=0
goto check_parameter_2nd
:check_parameter_1st_done
for /f "tokens=1,2*" %%i in ('reg query %REG_FULLKEY% /v %REG_CANCEL_VALUE%'       ) DO ( if "%%i"=="%REG_CANCEL_VALUE%"       ( set /a param1=%%k ) )

rem	----- check 2nd parameter -----
:check_parameter_2nd
reg query %REG_FULLKEY% /v %REG_CANCELNOTIFY_VALUE% 1>nul 2>&1
if not ErrorLevel 1 goto check_parameter_2nd_done
set /a param2=0
goto check_parameter_3rd
:check_parameter_2nd_done
for /f "tokens=1,2*" %%i in ('reg query %REG_FULLKEY% /v %REG_CANCELNOTIFY_VALUE%' ) DO ( if "%%i"=="%REG_CANCELNOTIFY_VALUE%" ( set /a param2=%%k ) )

rem	----- check 3rd parameter -----
:check_parameter_3rd
reg query %REG_FULLKEY% /v %REG_EVENT_VALUE% 1>nul 2>&1
if not ErrorLevel 1 goto check_parameter_3rd_done
set /a param3=0
goto check_parameter_4th
:check_parameter_3rd_done
for /f "tokens=1,2*" %%i in ('reg query %REG_FULLKEY% /v %REG_EVENT_VALUE%'        ) DO ( if "%%i"=="%REG_EVENT_VALUE%"        ( set /a param3=%%k ) )

rem	----- check 4th parameter -----
:check_parameter_4th

:check_parameter_4th_sys_online
reg query %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_ONLINE% 1>nul 2>&1
if not ErrorLevel 1 goto check_parameter_4th_sys_online_EventMessageFile
set /a param4=0
goto check_parameter_4th_apl_online

:check_parameter_4th_sys_online_EventMessageFile
reg query %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_ONLINE% /v EventMessageFile 1>nul 2>&1
if not ErrorLevel 1 goto check_parameter_4th_sys_online_TypesSupported
echo "EventMessageFile" key on [%REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_ONLINE%] does not exist!
set param4=X
goto check_parameter_display_cur_settings

:check_parameter_4th_sys_online_TypesSupported
reg query %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_ONLINE% /v TypesSupported 1>nul 2>&1
if not ErrorLevel 1 goto check_parameter_4th_sys_online_EventMessageFile_val
echo "TypesSupported" key on [%REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_ONLINE%] does not exist!
set param4=X
goto check_parameter_display_cur_settings

:check_parameter_4th_sys_online_EventMessageFile_val
for /f "tokens=1,2*" %%i in ('reg query %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_ONLINE% /v EventMessageFile') DO (if "%%i"=="EventMessageFile" ( set EventMessageFile_val=^"%%k^") )
if "%EventMessageFile_val%"=="%REG_EVENTLOG_MSGFILE_VALUE%" goto check_parameter_4th_sys_online_TypesSupported_val
echo "%REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_ONLINE%\EventMessageFile" is invalid!
echo   (EventMessageFile=%EventMessageFile_val%)
set param4=X
goto check_parameter_display_cur_settings

:check_parameter_4th_sys_online_TypesSupported_val
for /f "tokens=1,2*" %%i in ('reg query %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_ONLINE% /v TypesSupported') DO (if "%%i"=="TypesSupported" ( set /a TypesSupported_val=^"%%k^") )
if "%TypesSupported_val%"=="%REG_EVENTLOG_TYPESUP_VALUE%" goto check_parameter_4th_sys_offline
echo "%REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_ONLINE%\TypesSupported" is invalid!
echo   (TypesSupported=%TypesSupported_val%)
set param4=X
goto check_parameter_display_cur_settings


:check_parameter_4th_sys_offline
reg query %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_OFFLINE% 1>nul 2>&1
if not ErrorLevel 1 goto check_parameter_4th_sys_offline_EventMessageFile
set /a param4=0
goto check_parameter_4th_apl_online

:check_parameter_4th_sys_offline_EventMessageFile
reg query %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_OFFLINE% /v EventMessageFile 1>nul 2>&1
if not ErrorLevel 1 goto check_parameter_4th_sys_offline_TypesSupported
echo "EventMessageFile" key on [%REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_OFFLINE%] does not exist!
set param4=X
goto check_parameter_display_cur_settings

:check_parameter_4th_sys_offline_TypesSupported
reg query %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_OFFLINE% /v TypesSupported 1>nul 2>&1
if not ErrorLevel 1 goto check_parameter_4th_sys_offline_EventMessageFile_val
echo "TypesSupported" key on [%REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_OFFLINE%] does not exist!
set param4=X
goto check_parameter_display_cur_settings

:check_parameter_4th_sys_offline_EventMessageFile_val
for /f "tokens=1,2*" %%i in ('reg query %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_OFFLINE% /v EventMessageFile') DO (if "%%i"=="EventMessageFile" ( set EventMessageFile_val=^"%%k^") )
if "%EventMessageFile_val%"=="%REG_EVENTLOG_MSGFILE_VALUE%" goto check_parameter_4th_sys_offline_TypesSupported_val
echo "%REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_OFFLINE%\EventMessageFile" is invalid!
echo   (EventMessageFile=%EventMessageFile_val%)
set param4=X
goto check_parameter_display_cur_settings

:check_parameter_4th_sys_offline_TypesSupported_val
for /f "tokens=1,2*" %%i in ('reg query %REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_OFFLINE% /v TypesSupported') DO (if "%%i"=="TypesSupported" ( set /a TypesSupported_val=^"%%k^") )
if "%TypesSupported_val%"=="%REG_EVENTLOG_TYPESUP_VALUE%" goto check_parameter_4th_customsd
echo "%REG_EVENTLOG_KEY%\System\%REG_EVENTLOG_KEY_OFFLINE%\TypesSupported" is invalid!
echo   (TypesSupported=%TypesSupported_val%)
set param4=X
goto check_parameter_display_cur_settings

:check_parameter_4th_customsd
reg query %REG_EVENTLOG_KEY%\System /v %REG_EVENT_ACCESS_VALUE% 1>nul 2>&1
if not ErrorLevel 1 goto check_parameter_4th_customsd_val
echo "%REG_EVENTLOG_KEY%\System\CustomSD" does not exist!
set param4=X
goto check_parameter_display_cur_settings

:check_parameter_4th_customsd_val
rem for /f "tokens=1,2*" %%i in ('reg query %REG_EVENTLOG_KEY%\System /v %REG_EVENT_ACCESS_VALUE%') DO (if "%%i"=="%REG_EVENT_ACCESS_VALUE%" ( set CustomSD_val=^"%%k^") )
rem if "%CustomSD_val%"=="%REG_EVENTLOG_CUSTOMSD_VALUE%" goto check_parameter_4th_result_system
rem echo "%REG_EVENTLOG_KEY%\System\CustomSD" is invalid!
rem echo   (CustomSD=%CustomSD_val%)
rem set param4=X
rem goto check_parameter_display_cur_settings

:check_parameter_4th_result_system
rem Result is "system"
set /a param4=1
goto check_parameter_display_cur_settings


:check_parameter_4th_apl_online
reg query %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_ONLINE% 1>nul 2>&1
if not ErrorLevel 1 goto check_parameter_4th_apl_online_EventMessageFile
set /a param4=0
goto check_parameter_display_cur_settings

:check_parameter_4th_apl_online_EventMessageFile
reg query %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_ONLINE% /v EventMessageFile 1>nul 2>&1
if not ErrorLevel 1 goto check_parameter_4th_apl_online_TypesSupported
echo "EventMessageFile" key on [%REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_ONLINE%] does not exist!
set param4=X
goto check_parameter_display_cur_settings

:check_parameter_4th_apl_online_TypesSupported
reg query %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_ONLINE% /v TypesSupported 1>nul 2>&1
if not ErrorLevel 1 goto check_parameter_4th_apl_online_EventMessageFile_val
echo "TypesSupported" key on [%REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_ONLINE%] does not exist!
set param4=X
goto check_parameter_display_cur_settings

:check_parameter_4th_apl_online_EventMessageFile_val
for /f "tokens=1,2*" %%i in ('reg query %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_ONLINE% /v EventMessageFile' ) DO ( if "%%i"=="EventMessageFile" ( set EventMessageFile_val=^"%%k^") )
if "%EventMessageFile_val%"=="%REG_EVENTLOG_MSGFILE_VALUE%" goto check_parameter_4th_apl_online_TypesSupported_val
echo "%REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_ONLINE%\EventMessageFile" is invalid!
echo   (EventMessageFile=%EventMessageFile_val%)
set param4=X
goto check_parameter_display_cur_settings

:check_parameter_4th_apl_online_TypesSupported_val
for /f "tokens=1,2*" %%i in ('reg query %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_ONLINE% /v TypesSupported' ) DO ( if "%%i"=="TypesSupported" ( set /a TypesSupported_val=^"%%k^") )
if "%TypesSupported_val%"=="%REG_EVENTLOG_TYPESUP_VALUE%" goto check_parameter_4th_apl_offline
echo "%REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_ONLINE%\TypesSupported" is invalid!
echo   (TypesSupported=%TypesSupported_val%)
set param4=X
goto check_parameter_display_cur_settings


:check_parameter_4th_apl_offline
reg query %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_OFFLINE% 1>nul 2>&1
if not ErrorLevel 1 goto check_parameter_4th_apl_offline_EventMessageFile
set /a param4=0
goto check_parameter_display_cur_settings

:check_parameter_4th_apl_offline_EventMessageFile
reg query %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_OFFLINE% /v EventMessageFile 1>nul 2>&1
if not ErrorLevel 1 goto check_parameter_4th_apl_offline_TypesSupported
echo "EventMessageFile" key on [%REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_OFFLINE%] does not exist!
set param4=X
goto check_parameter_display_cur_settings

:check_parameter_4th_apl_offline_TypesSupported
reg query %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_OFFLINE% /v TypesSupported 1>nul 2>&1
if not ErrorLevel 1 goto check_parameter_4th_apl_offline_EventMessageFile_val
echo "TypesSupported" key on [%REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_OFFLINE%] does not exist!
set param4=X
goto check_parameter_display_cur_settings

:check_parameter_4th_apl_offline_EventMessageFile_val
for /f "tokens=1,2*" %%i in ('reg query %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_OFFLINE% /v EventMessageFile' ) DO ( if "%%i"=="EventMessageFile" ( set EventMessageFile_val=^"%%k^") )
if "%EventMessageFile_val%"=="%REG_EVENTLOG_MSGFILE_VALUE%" goto check_parameter_4th_apl_offline_TypesSupported_val
echo "%REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_OFFLINE%\EventMessageFile" is invalid!
echo   (EventMessageFile=%EventMessageFile_val%)
set param4=X
goto check_parameter_display_cur_settings

:check_parameter_4th_apl_offline_TypesSupported_val
for /f "tokens=1,2*" %%i in ('reg query %REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_OFFLINE% /v TypesSupported' ) DO ( if "%%i"=="TypesSupported" ( set /a TypesSupported_val=^"%%k^") )
if "%TypesSupported_val%"=="%REG_EVENTLOG_TYPESUP_VALUE%" goto check_parameter_4th_result_application
echo "%REG_EVENTLOG_KEY%\Application\%REG_EVENTLOG_KEY_OFFLINE%\TypesSupported" is invalid!
echo   (TypesSupported=%TypesSupported_val%)
set param4=X
goto check_parameter_display_cur_settings

:check_parameter_4th_result_application
rem Result is "Application"
set /a param4=2
goto check_parameter_display_cur_settings


:check_parameter_display_cur_settings
echo.
echo Current settings are ...
echo    ^-^-^> %param1% %param2% %param3% %param4%



rem		//////////////////////////////////////////////
rem		// End
rem		//////////////////////////////////////////////
:end
echo.
echo ## If you modified current settings, 
echo ##   please restart your system in order to load these new settings!

rem echo.
rem pause
